api/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('partners', views.ClientUpdateView.as_view()),
    path('employees', views.BenevoleUpdateView.as_view()),
]

common/urls.py
from django.apps import apps
from django.contrib import admin
from django.urls import include, path

from two_factor.urls import urlpatterns as tf_urls

from common import views

handler500 = 'common.views.error_view'

urlpatterns = [
    # Overwrite two factor view to redirect authenticated users
    path('account/login/', views.LoginView.as_view(), name='login'),
    path('', include(tf_urls)),

    path('admin/', admin.site.urls),

    path('accounts/', include('django.contrib.auth.urls')),
    path('accounts/list/', views.UtilisateurListView.as_view(),
         name='utilisateur-list'),
    path('accounts/list/inactive/', views.UtilisateurListView.as_view(is_active=False),
         name='utilisateur-desactive-list'),
    path('accounts/new/', views.UtilisateurUpdateView.as_view(is_create=True),
         name='utilisateur-add'),
    path('accounts/<int:pk>/edit/', views.UtilisateurUpdateView.as_view(),
         name='utilisateur-edit'),
    path('accounts/<int:pk>/otp-reinit/', views.UtilisateurOtpReinitView.as_view(),
         name='utilisateur-otp-reinit'),

    path('benevoles/', include('benevole.urls')),

    path('media/<path:path>', views.MediaServeView.as_view(), name='media'),

    path('npa/autocomplete/', views.NPALocaliteAutocomplete.as_view(), name='npalocalite-search'),
    path('referent/autocomplete/', views.ReferentFactAutocomplete.as_view(), name='referent-fact-search'),
]

if apps.is_installed('api'):
    urlpatterns.append(path('api/', include('api.urls')))

if apps.is_installed('debug_toolbar'):
    urlpatterns.append(path('__debug__/', include('debug_toolbar.urls')))

common/models.py
from django.contrib.auth.models import AbstractUser
from django.contrib.auth.base_user import BaseUserManager
from django.contrib.contenttypes.fields import GenericForeignKey
from django.contrib.contenttypes.models import ContentType
from django.contrib.postgres.fields import ArrayField
from django.db import models

from .distance import get_point_from_address, wgs84_to_mn95
from .utils import icon_url

GEOADMIN_MAP_URL_TEMPLATE = (
    "https://map.geo.admin.ch/?lang=fr&topic=ech&bgLayer=ch.swisstopo.pixelkarte-farbe"
    "&E={long}&N={lat}&zoom=8&crosshair=marker"
)
GOOGLE_MAP_URL_TEMPLATE = "https://www.google.com/maps/search/?api=1&query={lat}%2C{long}"


class GeolocMixin:
    def check_geolocalized(self):
        if self.empl_geo:
            return True
        return self.geolocalize()

    def geolocalize(self, save=True):
        lon_lat = get_point_from_address(self.rue, f"{self.npa} {self.localite}")
        if lon_lat:
            self.empl_geo = list(lon_lat)
            if save:
                self.save()
            return True
        elif self.empl_geo:
            self.empl_geo = None
            if save:
                self.save()
        return False

    @property
    def map_link(self):
        if not self.empl_geo:
            return None
        pt = wgs84_to_mn95(*self.empl_geo)
        return GEOADMIN_MAP_URL_TEMPLATE.format(long=pt.x, lat=pt.y)

    @property
    def gmap_link(self):
        if not self.empl_geo:
            return None
        wgs84_to_mn95(*self.empl_geo)
        return GOOGLE_MAP_URL_TEMPLATE.format(long=self.empl_geo[0], lat=self.empl_geo[1])


class CustomUserManager(BaseUserManager):
    def create_user(self, email, password, **extra_fields):
        if not email:
            raise ValueError('Le courriel est obligatoire')
        email = self.normalize_email(email)
        user = self.model(email=email, **extra_fields)
        user.set_password(password)
        user.save()
        return user

    def create_superuser(self, email, password, **extra_fields):
        extra_fields.setdefault('is_staff', True)
        extra_fields.setdefault('is_superuser', True)
        return self.create_user(email, password, **extra_fields)


class Utilisateur(AbstractUser):
    """Main user model."""
    email = models.EmailField('Courriel', unique=True)
    fonction = models.CharField('Fonction', max_length=100, blank=True)

    username = None
    USERNAME_FIELD = 'email'
    REQUIRED_FIELDS = []
    objects = CustomUserManager()

    def __str__(self):
        return ' '.join([self.last_name, self.first_name]) if self.last_name else self.email

    @property
    def is_benevole(self):
        return hasattr(self, 'benevole') and not self.has_perm('client.change_client')


class DistanceFigee(models.Model):
    """
    Distance figée de manière statique entre deux points, pour éviter d'éventuelles
    variation du service d'interrogation des distances (par ex. pour une facturation
    stable des km d'un transport régulier).
    """
    created = models.DateTimeField(auto_now_add=True)
    empl_geo_dep = ArrayField(models.FloatField(), size=2, verbose_name="Empl. géo de départ")
    empl_geo_arr = ArrayField(models.FloatField(), size=2, verbose_name="Empl. géo d’arrivée")
    distance = models.DecimalField("Distance [km]", max_digits=5, decimal_places=1)

    class Meta:
        constraints = [
            models.UniqueConstraint(
                fields=['empl_geo_dep', 'empl_geo_arr'], name='trajet_unique'
            ),
        ]

    def __str__(self):
        return f"Distance figée de {self.distance} entre {self.empl_geo_dep} et {self.empl_geo_arr}"


class TypeFichier(models.TextChoices):
    DOC_GENERAL = 'doc', "Document général"
    QUEST_ALARME = 'quest', "Questionnaire signé"
    CONTRAT_ALARME = 'contrat', "Contrat signé"


def content_type_path(instance, filename):
     return "fichiers/{0}/{1}".format(instance.content_type.model, filename)


class Fichier(models.Model):
    """
    Modèle générique de stockage de fichier pour différents autres modèles (clients, bénévoles, etc.).
    """
    content_type = models.ForeignKey(ContentType, on_delete=models.CASCADE)
    object_id = models.PositiveIntegerField()
    content_object = GenericForeignKey("content_type", "object_id")
    titre = models.CharField("Titre", max_length=150)
    fichier = models.FileField("Fichier", upload_to=content_type_path)
    typ = models.CharField("Type de document", max_length=10, choices=TypeFichier.choices, default='doc')
    qui = models.ForeignKey(Utilisateur, on_delete=models.SET_NULL, blank=True, null=True, related_name='+')
    quand = models.DateTimeField()

    def __str__(self):
        return f'Fichier «{self.titre}» pour {self.content_object}'

    def delete(self, **kwargs):
        self.fichier.storage.delete(self.fichier.name)
        super().delete(**kwargs)

    @property
    def icon(self):
        return icon_url(self.fichier.name)

common/views.py
from io import BytesIO

import httpx

from django.conf import settings
from django.contrib import messages
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.core.exceptions import ObjectDoesNotExist, PermissionDenied, ValidationError
from django.core.mail import send_mail
from django.core.paginator import EmptyPage, PageNotAnInteger, Paginator
from django.db import transaction
from django.db.models import Q
from django.http import (
    FileResponse, HttpResponse, HttpResponseRedirect, HttpResponseServerError,
    JsonResponse
)
from django.shortcuts import get_object_or_404
from django.template import loader
from django.urls import reverse, reverse_lazy
from django.utils import timezone
from django.utils.crypto import get_random_string
from django.utils.module_loading import import_string
from django.views.generic import (
    ListView as DjangoListView, TemplateView, UpdateView, View
)
from django.views.static import serve

from two_factor.views import LoginView as DTFALoginView

from common.distance import get_point_from_address
from common.export import OpenXMLExport
from common.models import Utilisateur
from client.models import Referent
from . import forms
from .utils import canton_abrev


def error_view(request):
    template = loader.get_template('500.html')
    return HttpResponseServerError(template.render({'main_logo': settings.MAIN_LOGO}))


class LoginView(DTFALoginView):
    redirect_authenticated_user = True


class NPALocaliteAutocomplete(View):
    # Also read https://swisspost.opendatasoft.com/explore/dataset/plz_verzeichnis_v2/api/
    POST_API = 'https://swisspost.opendatasoft.com/api/records/1.0/search/'

    def get(self, request, *args, **kwargs):
        values = []
        q = request.GET.get('q').strip().lower().replace('saint', 'st')
        if q:
            params = {'dataset': 'plz_verzeichnis_v2', 'rows': 30, 'q': q}
            try:
                response = httpx.get(self.POST_API, params=params, headers={'Accept': "application/json"})
            except httpx.HTTPError:
                return JsonResponse({'result': 'error', 'message': "Échec de connexion à l’API SwissPost"})
            results = response.json()
            # filtrer plz 10 ou 20 (adresses de domiciles)
            values = [
                f"{res['fields']['postleitzahl']} {res['fields']['ortbez27']}"
                for res in results.get('records', [])
                if (
                    res['fields']['plz_typ'] in (10, 20) and
                    (not q.isdigit() or res['fields']['postleitzahl'].startswith(q))
                )
            ]
            values = [
                {'value': val, 'label': val} for val in values
            ]
        return JsonResponse(values, safe=False)


class ReferentFactAutocomplete(View):
    def get(self, request, *args, **kwargs):
        term = request.GET.get('q').strip()
        query = Referent.objects.exclude(
            Q(date_archive__isnull=False) | Q(facturation_pour=[])
        ).filter(
            Q(nom__unaccent__icontains=term)
        )[:15]
        referents = [
            {'label': f"{ref.nom_prenom}, {ref.rue_localite()}", 'value': ref.pk}
            for ref in query
        ]
        results = []
        seen_labels = set()
        for ref in referents:
            if ref['label'] in seen_labels:
                continue
            results.append(ref)
            seen_labels.add(ref['label'])
        return JsonResponse(results, safe=False)


class GeoAddressFormMixin:
    geo_required = True

    def geo_enabled(self, instance):
        return settings.QUERY_GEOADMIN_FOR_ADDRESS

    def clean(self):
        cleaned_data = super().clean()
        if set(self.changed_data).intersection({'npa', 'localite', 'rue'}) and self.geo_enabled(self.instance):
            lon_lat = get_point_from_address(cleaned_data.get('rue'), f"{cleaned_data.get('npa')} {cleaned_data.get('localite')}")
            if lon_lat:
                self.instance.empl_geo = list(lon_lat)
            elif self.geo_required:
                raise ValidationError("Impossible de géolocaliser cette adresse.")
        return cleaned_data


class GeoAddressMixin:
    def geo_enabled(self, instance):
        return settings.QUERY_GEOADMIN_FOR_ADDRESS

    def form_valid(self, form):
        response = super().form_valid(form)
        if set(form.changed_data).intersection({'npa', 'localite', 'rue'}) and self.geo_enabled(form.instance):
            form.instance.geolocalize()
        return response


class ExportableMixin:
    export_class = OpenXMLExport
    col_widths = [50]

    def dispatch(self, request, *args, **kwargs):
        self.export_flag = request.GET.get('export', None) == '1'
        return super().dispatch(request, *args, **kwargs)

    def get_context_data(self, **kwargs):
        return {**super().get_context_data(**kwargs), 'exportable': True}

    @staticmethod
    def _serialize(value):
        if value is None:
            return ''
        return str(value)

    def export_lines(self, context):
        raise NotImplementedError("Subclasses of ExportableMixin must implement export_lines()")

    def render_to_response(self, context, **response_kwargs):
        if self.export_flag:
            export = self.export_class(col_widths=self.col_widths)
            export.fill_data(self.export_lines(context))
            return export.get_http_response(self.__class__.__name__.replace('View', '') + '.xlsx')
        else:
            return super().render_to_response(context, **response_kwargs)


class JournalMixin:
    def _create_instance(self, **kwargs):
        raise NotImplementedError

    def journalize(self, form, changed_values=True, add_message=None):
        if self.is_create:
            if not add_message and not hasattr(self, 'journal_add_message'):
                return
            journal_msg = add_message or self.journal_add_message.format(obj=form.instance)
        else:
            changes = form.get_changed_string(changed_values=changed_values)
            if changes:
                journal_msg = self.journal_edit_message.format(obj=form.instance, fields=changes)
            else:
                return
        self._create_instance(
            description=journal_msg, quand=timezone.now(),
            qui=self.request.user if not self.request.user.is_anonymous else None
        )


class BenevoleMixin:
    """Accès limité à un compte de bénévole, définition de self.benev"""
    def dispatch(self, request, *args, **kwargs):
        try:
            self.benev = request.user.benevole
        except ObjectDoesNotExist:
            raise PermissionDenied("Aucun bénévole n’est lié à votre compte utilisateur.")
        return super().dispatch(request, *args, **kwargs)


class CreateUpdateView(UpdateView):
    """Mix generic Create and Update views."""
    template_name = 'alarme/general_edit.html'
    is_create = False
    json_response = False

    def get_object(self):
        return None if self.is_create else super().get_object()

    def get_client(self):
        return None

    def get_context_data(self, **kwargs):
        return {**super().get_context_data(**kwargs), 'client': self.get_client()}

    def form_valid(self, form):
        with transaction.atomic():
            if self.is_create:
                self.object = form.save()
                if hasattr(self, 'journalize'):
                    self.journalize(form)
            else:
                # Journalize before saving form so it's possible to get previous
                # version of objects during journalization.
                if hasattr(self, 'journalize'):
                    self.journalize(form, changed_values=True)
                self.object = form.save()
        if not self.json_response:
            success_message = self.get_success_message(self.object)
            if success_message:
                messages.success(self.request, success_message)
            return HttpResponseRedirect(self.get_success_url())


class FilterFormMixin:
    filter_formclass = None
    return_all_if_unbound = True

    def get(self, request, *args, **kwargs):
        if self.filter_formclass:
            self.filter_form = self.filter_formclass(data=request.GET or None)
        else:
            self.filter_form = None
        return super().get(request, *args, **kwargs)

    def get_queryset(self, base_qs=None):
        items = super().get_queryset() if base_qs is None else base_qs
        if self.filter_form.is_bound and self.filter_form.is_valid() and (
             self.return_all_if_unbound or any(self.filter_form.cleaned_data.values())
        ):
            items = self.filter_form.filter(items)
        elif not self.return_all_if_unbound:
            return self.model.objects.none()
        return items

    def get_context_data(self, *args, **kwargs):
        return {
            **super().get_context_data(**kwargs),
            'form': self.filter_form,
        }


class BasePDFView(View):
    obj_class = None
    pdf_class = None
    produce_kwargs = {}

    def get_object(self):
        return get_object_or_404(self.obj_class, pk=self.kwargs[getattr(self, 'pk_url_kwarg', 'pk')])

    def get(self, request, *args, as_attachment=True, **kwargs):
        instance = self.get_object()
        temp = BytesIO()
        if isinstance(self.pdf_class, str):
            PDFClass = import_string(self.pdf_class % {'CANTON_APP': settings.CANTON_APP})
        else:
            PDFClass = self.pdf_class
        pdf = PDFClass(temp)
        pdf.produce(instance, **self.produce_kwargs)
        filename = pdf.get_filename(instance)
        temp.seek(0)
        return FileResponse(temp, as_attachment=as_attachment, filename=filename)


class MediaServeView(View):
    def get(self, request, *args, **kwargs):
        if self.request.get_host() == 'localhost:8000':
            return serve(request, kwargs['path'], document_root=settings.MEDIA_ROOT)

common/templates/fichier_edit.html
<form id="standalone-form" class="{{ form_classes }}" method="post" action="{{ request.path }}">
    <div class="mb-2">Ajout fichier pour: <b>{{ obj }}</b></div>
    {% csrf_token %}
    {% if form.intro_text %}<div class="mb-2">{{ form.intro_text }}</div>{% endif %}
    {% for hidden in form.hidden_fields %}{{ hidden }}{% endfor %}
    {{ form.non_field_errors }}
    {% for field in form.visible_fields %}
    <div class="form-group mb-2">
        {{ field.label_tag }} {{ field }}
        {{ field.errors }}
    </div>
    {% endfor %}
</form>

common/templates/utilisateur_edit.html
{% extends "base.html" %}

{% block extrastyle %}
<style>span.helptext { display: none; }</style>
{% endblock %}

{% block breadcrumb %}
<li class="breadcrumb-item"><a href="{% url 'home' %}">Accueil</a></li>
<li class="breadcrumb-item"><a href="{% url 'utilisateur-list' %}">Utilisateurs</a></li>
<li class="breadcrumb-item active" aria-current="page">
    {% if object.pk %}{{ object.last_name }} {{ object.first_name }}{% else %}Nouveau{% endif %}
</li>
{% endblock %}

{% block content %}
    <div class="row mb-3">
        {% if form.instance.pk %}
        <div class="col text-end">
            <!-- form class="form-reinit form inline" action="{ url 'utilisateur-password-reinit' object.pk }" method="post">{% csrf_token %}
                <button id="reinit" class="btn btn-outline-primary btn-sm">Réinit. mot de passe</button>
            </form -->
            <form class="form inline" action="{% url 'utilisateur-otp-reinit' object.pk %}" method="post">
                {% csrf_token %}
                <button class="btn btn-outline-primary btn-sm"
                        data-confirm="Voulez-vous vraiment réinitialiser le jeton de 2ème facteur d’authentification pour cette personne ?">Réinit. 2ème facteur d’auth.</button>
            </form>
        </div>
        {% endif %}
    </div>
    <div class="row justify-content-center">
        <div class="col-6">
            <form action="." method="post">
                {% csrf_token %}
                <table class="table table-sm">
                    {{ form.as_table }}
                </table>
                {% if view.is_create %}
                <p>Un nouveau mot de passe généré aléatoirement sera envoyé par courriel à l’adresse indiquées pour cette personne.</p>
                {% endif %}
                <div id="actions" class="row border-top mt-2">
                    {% if form.instance.pk %}
                    <div class="col mt-3">
                        {% if view.delete_url %}
                        <button class="btn btn-sm btn-danger" name="delete" type="submit"
                            data-confirm="Voulez-vous vraiment désactiver cet utilisateur ?"
                            formaction="{{ view.delete_url }}" title="Cet utilisateur n'apparaîtra plus dans les listes"
                            >Désactiver</button>
                        {% endif %}
                    </div>
                    {% endif %}
                    <div class="col mt-3 text-end">
                        <a class="btn btn-sm btn-secondary" href="javascript: history.go(-1)">Annuler</a>
                        <button class="btn btn-sm btn-primary" name="save" type="submit">{% if object.pk %}Enregistrer{% else %}Créer{% endif %}</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
{% endblock %}

common/templates/utilisateurs.html
{% extends "base.html" %}

{% block title %}Liste des utilisateurs{% endblock %}

{% block breadcrumb %}
<li class="breadcrumb-item"><a href="{% url 'home' %}">Accueil</a></li>
<li class="breadcrumb-item active" aria-current="page">Utilisateurs</li>
{% endblock %}

{% block content %}
    <div class="row border-bottom mb-3">
        <div class="col"><h2>Utilisateurs {% if view.is_active %}activés{% else %}désactivés{% endif %}</h2></div>
        {% if perms.common.add_utilisateur %}
        <div class="col text-end">
            {% if view.is_active %}
            <a class="btn btn-sm btn-outline-primary" href="{% url 'utilisateur-desactive-list' %}">Utilisateurs désactivés</a>
            {% else %}
            <a class="btn btn-sm btn-outline-primary" href="{% url 'utilisateur-list' %}">Utilisateurs actifs</a>
            {% endif %}
            <a class="btn btn-sm btn-outline-primary" href="{% url 'utilisateur-add' %}">Nouveau</a>
        </div>
        {% endif %}
    </div>

    <form class="immediate_submit table-filter unmonitor" method="get" action=".">
    <table class="table">
        <thead class="sticky">
            <tr><th>Nom, prénom</th><th>Courriel</th><th>Fonction</th><th>Groupes</th></tr>
            <tr class="filters">
                <td>{{ form.nom }}</td><td></td><td></td><td>{{ form.groupe }}</td>
            </tr>
        </thead>
        <tbody id="filter_container">
        {% for util in object_list %}
            <tr>
                <td><a href="{% url 'utilisateur-edit' util.pk %}">{{ util.last_name }} {{ util.first_name }}</a></td>
                <td><a href="mailto:{{ util.email }}">{{ util.email }}</a></td>
                <td>{{ util.fonction }}</td>
                <td>{% for grp in util.groups.all %}<div>{{ grp.name }}</div>{% endfor %}</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
    </form>

    {% include 'pagination.html' %}
{% endblock %}